## libvpl-tools 1.4.0

=== CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################

cmake_minimum_required(VERSION 3.13.0)
if(MSVC)
  cmake_policy(SET CMP0091 NEW)
endif()

file(STRINGS "version.txt" version_txt)
project(vpl-tools VERSION ${version_txt})

set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH};${CMAKE_CURRENT_SOURCE_DIR}/cmake")

#
# Project configuration options
#

# Set default build type to Release if not specified
if(NOT CMAKE_BUILD_TYPE)
  message(STATUS "Default CMAKE_BUILD_TYPE not set using Release")
  set(CMAKE_BUILD_TYPE
      "Release"
      CACHE
        STRING
        "Choose build type from: None Debug Release RelWithDebInfo MinSizeRel"
        FORCE)
endif()

# More code hardening on Windows
if(MSVC)
  if(${use_control_flow_guard})
    message("Setting CONTROL FLOW GUARD")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /guard:cf")
    set(CMAKE_EXE_LINKER_FLAGS "/guard:cf /DYNAMICBASE")
  endif()
  if(${use_qspectre})
    message("Setting QSPECTRE")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /Qspectre")
  endif()
endif()

# Project options
option(BUILD_SHARED_LIBS "Build shared instead of static libraries." OFF)
option(BUILD_TESTS "Build tests." OFF)

set(BUILD_EXPERIMENTAL
    ON
    CACHE BOOL "Build tools with EXPERIMENTAL APIs.")

# Test tool options for surface sharing
if(WIN32)
  set(TOOLS_DEFAULT_SCREEN_CAPTURE ON)
  set(TOOLS_DEFAULT_RENDER ON)
  set(TOOLS_DEFAULT_OPENCL ON)
  set(TOOLS_DEFAULT_X11 OFF)
else()
  set(TOOLS_DEFAULT_SCREEN_CAPTURE ON)
  set(TOOLS_DEFAULT_RENDER ON)
  set(TOOLS_DEFAULT_OPENCL OFF)
  set(TOOLS_DEFAULT_X11 ON)
endif()

option(TOOLS_ENABLE_SCREEN_CAPTURE
       "Enable screen capture in surface sharing test tools."
       ${TOOLS_DEFAULT_SCREEN_CAPTURE})

option(TOOLS_ENABLE_RENDER "Enable rendering in surface sharing test tools."
       ${TOOLS_DEFAULT_RENDER})

option(TOOLS_ENABLE_OPENCL "Enable OpenCL in surface sharing test tools."
       ${TOOLS_DEFAULT_OPENCL})

option(TOOLS_ENABLE_X11 "Enable X11 in surface sharing test tools."
       ${TOOLS_DEFAULT_X11})

option(USE_MSVC_STATIC_RUNTIME
       "Link MSVC runtime statically to all components." OFF)

if(USE_MSVC_STATIC_RUNTIME)
  set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
endif()

# Set output directories
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})

include(cmake/InstallDirs.cmake)
include(cmake/PackageTarget.cmake)

# Set POSITION_INDEPENDENT_CODE property for all targets
set(CMAKE_POSITION_INDEPENDENT_CODE true)

# Keep executable bits on shared objects when installing regardless of distro
set(CMAKE_INSTALL_SO_NO_EXE 0)

include(cmake/CompileOptions.cmake)

if(BUILD_TESTS)
  include(CTest)
  enable_testing()
  # Build googletest
  set(BUILD_GMOCK
      OFF
      CACHE BOOL "" FORCE)
  set(INSTALL_GTEST
      OFF
      CACHE BOOL "" FORCE)
  set(gtest_disable_pthreads
      OFF
      CACHE BOOL "" FORCE)
  set(gtest_force_shared_crt
      ON
      CACHE BOOL "" FORCE)
  set(gtest_hide_internal_symbols
      OFF
      CACHE BOOL "" FORCE)

  add_subdirectory(ext/googletest)
  add_library(GTest::gtest ALIAS gtest)
  add_library(GTest::gtest_main ALIAS gtest_main)
endif()

add_subdirectory(tools)

install(
  FILES third-party-programs.txt
  DESTINATION ${VPL_INSTALL_LICENSEDIR}
  COMPONENT ${VPL_COMPONENT_LIB})

install(
  FILES LICENSE
  RENAME license.txt
  DESTINATION ${VPL_INSTALL_LICENSEDIR}
  COMPONENT ${VPL_COMPONENT_LIB})

set(CMAKE_INSTALL_SYSTEM_RUNTIME_COMPONENT ${VPL_COMPONENT_LIB})
include(InstallRequiredSystemLibraries)

message(
  STATUS "---------------- Configuration summary ------------------------------"
)
message(STATUS "CMake:")
message(STATUS "  CMAKE_VERSION                   : ${CMAKE_VERSION}")
message(STATUS "  CMAKE_GENERATOR                 : ${CMAKE_GENERATOR}")
message(STATUS "  CMAKE_BUILD_TOOL                : ${CMAKE_BUILD_TOOL}")
message(STATUS "Target:")
message(STATUS "  CMAKE_SYSTEM_NAME               : ${CMAKE_SYSTEM_NAME}")
message(STATUS "  CMAKE_SYSTEM_VERSION            : ${CMAKE_SYSTEM_VERSION}")
message(STATUS "  CMAKE_SYSTEM_PROCESSOR          : ${CMAKE_SYSTEM_PROCESSOR}")
message(STATUS "General:")
message(STATUS "  CMAKE_BUILD_TYPE                : ${CMAKE_BUILD_TYPE}")
message(STATUS "  CMAKE_TOOLCHAIN_FILE            : ${CMAKE_TOOLCHAIN_FILE}")
message(STATUS "  CMAKE_C_COMPILER                : ${CMAKE_C_COMPILER}")
message(STATUS "  CMAKE_CXX_COMPILER              : ${CMAKE_CXX_COMPILER}")
if(CMAKE_SIZEOF_VOID_P EQUAL 8)
  message(STATUS "  Build architecture              : 64-bit")
elseif(CMAKE_SIZEOF_VOID_P EQUAL 4)
  message(STATUS "  Build architecture              : 32-bit")
endif()
message(STATUS "Flags:")
message(STATUS "  CMAKE_C_FLAGS                   : ${CMAKE_C_FLAGS}")
message(STATUS "  CMAKE_CXX_FLAGS                 : ${CMAKE_CXX_FLAGS}")
message(STATUS "Release flags:")
message(STATUS "  CMAKE_C_FLAGS_RELEASE           : ${CMAKE_C_FLAGS_RELEASE}")
message(STATUS "  CMAKE_CXX_FLAGS_RELEASE         : ${CMAKE_CXX_FLAGS_RELEASE}")
message(STATUS "Debug flags:")
message(STATUS "  CMAKE_C_FLAGS_DEBUG             : ${CMAKE_C_FLAGS_DEBUG}")
message(STATUS "  CMAKE_CXX_FLAGS_DEBUG           : ${CMAKE_CXX_FLAGS_DEBUG}")
message(STATUS "RelWithDebRT flags:")
message(
  STATUS "  CMAKE_C_FLAGS_RELWITHDEBRT      : ${CMAKE_C_FLAGS_RELWITHDEBRT}")
message(
  STATUS "  CMAKE_CXX_FLAGS_RELWITHDEBRT    : ${CMAKE_CXX_FLAGS_RELWITHDEBRT}")
message(STATUS "Install:")
message(STATUS "  CMAKE_INSTALL_PREFIX            : ${CMAKE_INSTALL_PREFIX}")
message(
  STATUS "  CMAKE_INSTALL_FULL_BINDIR       : ${CMAKE_INSTALL_FULL_BINDIR}")
message(
  STATUS "  CMAKE_INSTALL_FULL_INCLUDEDIR   : ${CMAKE_INSTALL_FULL_INCLUDEDIR}")
message(
  STATUS "  CMAKE_INSTALL_FULL_LIBDIR       : ${CMAKE_INSTALL_FULL_LIBDIR}")
message(
  STATUS "  CMAKE_INSTALL_FULL_DOCDIR       : ${CMAKE_INSTALL_FULL_DOCDIR}")
message(
  STATUS "  VPL_INSTALL_FULL_PKGCONFIGDIR   : ${VPL_INSTALL_FULL_PKGCONFIGDIR}")
message(
  STATUS "  VPL_INSTALL_FULL_CMAKEDIR       : ${VPL_INSTALL_FULL_CMAKEDIR}")
message(STATUS "  VPL_INSTALL_FULL_ENVDIR         : ${VPL_INSTALL_FULL_ENVDIR}")
message(
  STATUS "  VPL_INSTALL_FULL_MODFILEDIR     : ${VPL_INSTALL_FULL_MODFILEDIR}")
message(
  STATUS "  VPL_INSTALL_FULL_EXAMPLEDIR     : ${VPL_INSTALL_FULL_EXAMPLEDIR}")
message(
  STATUS "  VPL_INSTALL_FULL_LICENSEDIR     : ${VPL_INSTALL_FULL_LICENSEDIR}")
message(
  STATUS "  VPL_INSTALL_FULL_PYTHONDIR      : ${VPL_INSTALL_FULL_PYTHONDIR}")
message(STATUS "Build:")
message(STATUS "  BUILD_SHARED_LIBS               : ${BUILD_SHARED_LIBS}")
message(STATUS "  BUILD_TESTS                     : ${BUILD_TESTS}")
message(STATUS "  BUILD_EXPERIMENTAL              : ${BUILD_EXPERIMENTAL}")
if(MSVC)
  message(
    STATUS "  USE_MSVC_STATIC_RUNTIME         : ${USE_MSVC_STATIC_RUNTIME}")
endif()
if(CMAKE_SYSTEM_NAME MATCHES Linux)
  message(STATUS "  ENABLE_VA                       : ${ENABLE_VA}")
  message(STATUS "  ENABLE_DRM                      : ${ENABLE_DRM}")
  message(STATUS "  ENABLE_WAYLAND                  : ${ENABLE_WAYLAND}")
  message(STATUS "  ENABLE_X11                      : ${ENABLE_X11}")
  message(STATUS "  ENABLE_DRI3                     : ${ENABLE_DRI3}")
  message(STATUS "  ENABLE_GTK4                     : ${ENABLE_GTK4}")
endif()

message(STATUS "Surface sharing test tools:")
message(
  STATUS "  TOOLS_ENABLE_SCREEN_CAPTURE     : ${TOOLS_ENABLE_SCREEN_CAPTURE}")
message(STATUS "  TOOLS_ENABLE_RENDER             : ${TOOLS_ENABLE_RENDER}")
message(STATUS "  TOOLS_ENABLE_OPENCL             : ${TOOLS_ENABLE_OPENCL}")
message(STATUS "  TOOLS_ENABLE_X11                : ${TOOLS_ENABLE_X11}")

=== tools/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################

cmake_minimum_required(VERSION 3.13.0)

add_subdirectory(cli)
add_subdirectory(legacy)

=== tools/cli/system_analyzer/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################
cmake_minimum_required(VERSION 3.13.0)
project(system_analyzer)

if(UNIX)
  find_package(PkgConfig REQUIRED)
  # note: pkg-config version for libva is *API* version
  pkg_check_modules(PKG_LIBVA libva>=1.2 IMPORTED_TARGET GLOBAL)
  pkg_check_modules(PKG_LIBVA_DRM libva-drm>=1.2 IMPORTED_TARGET GLOBAL)
  # Set defaults for ENABLE_VA
  if(PKG_LIBVA_FOUND AND PKG_LIBVA_DRM_FOUND)
    set(VA_DEFAULT ON)
  else()
    message(STATUS "libva not found.  Skipping system_analyzer.")
    return()
  endif()
  set(ENABLE_VA
      ${VA_DEFAULT}
      CACHE BOOL "Enable VA support in tools.")
else()
  message(STATUS "system_analyzer not supported on Windows")
  return()
endif()

if(NOT ENABLE_VA)
  message(STATUS "VA support disabled. Skipping system_analyzer.")
  return()
endif()

set(TARGET system_analyzer)
set(SOURCES system_analyzer.cpp)

add_executable(${TARGET} ${SOURCES})

if(BUILD_EXPERIMENTAL)
  target_compile_definitions(${TARGET} PRIVATE -DONEVPL_EXPERIMENTAL)
endif()

find_package(VPL REQUIRED)
target_link_libraries(${TARGET} VPL::dispatcher dl)

if(UNIX)
  if(PKG_LIBVA_FOUND)
    target_compile_definitions(${TARGET} PUBLIC -DLIBVA_SUPPORT)
    set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
    set(THREADS_PREFER_PTHREAD_FLAG TRUE)
    find_package(Threads REQUIRED)
    target_link_libraries(${TARGET} PkgConfig::PKG_LIBVA
                          PkgConfig::PKG_LIBVA_DRM Threads::Threads)
    target_include_directories(${TARGET} PUBLIC ${PKG_LIBVA_INCLUDE_DIRS})
  endif()
endif()

install(TARGETS ${TARGET} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
                                  COMPONENT ${VPL_COMPONENT_TOOLS})

=== tools/cli/val-surface-sharing/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################
cmake_minimum_required(VERSION 3.10.2)
project(val-surface-sharing)

if(NOT BUILD_EXPERIMENTAL)
  message(
    WARNING
      "BUILD_EXPERIMENTAL is set to OFF. val-surface-sharing will not be built."
  )
  return()
endif()

# Default install places 64 bit runtimes in the environment, so we want to do a
# 64 bit build by default.
if(WIN32)
  if(NOT DEFINED CMAKE_GENERATOR_PLATFORM)
    set(CMAKE_GENERATOR_PLATFORM
        x64
        CACHE STRING "")
    message(STATUS "Generator Platform set to ${CMAKE_GENERATOR_PLATFORM}")
  endif()
endif()

set(TARGET val-surface-sharing)

add_executable(${TARGET})

target_compile_definitions(${TARGET} PRIVATE -DONEVPL_EXPERIMENTAL)

target_sources(${TARGET} PRIVATE src/val-surface-sharing.cpp src/decode.cpp
                                 src/vpp.cpp src/encode.cpp src/util.cpp)

if(WIN32)
  target_sources(${TARGET} PRIVATE src/hw-device-d3d11.cpp)
else()
  target_sources(${TARGET} PRIVATE src/hw-device-vaapi.cpp)
endif()

# OpenCL is currently supported on Windows only for this tool
if(WIN32)
  # if OpenCL is not configured, disable use of it in this tool and print
  # warning
  find_package(OpenCL CONFIG)
  if(NOT OpenCL_FOUND)
    message(
      WARNING "*** OpenCL not found. OpenCL surface sharing will be disabled.")
    set(TOOLS_ENABLE_OPENCL OFF)
  endif()

  if(TOOLS_ENABLE_OPENCL)
    target_compile_definitions(${TARGET} PRIVATE -DTOOLS_ENABLE_OPENCL)
    target_sources(${TARGET} PRIVATE src/process-frames-ocl-d3d11.cpp)
    target_link_libraries(${TARGET} PRIVATE OpenCL::OpenCL)
  endif()
endif()

# Set default build type to Release if not specified
if(NOT CMAKE_BUILD_TYPE)
  message(STATUS "Default CMAKE_BUILD_TYPE not set using Release")
  set(CMAKE_BUILD_TYPE
      "Release"
      CACHE
        STRING
        "Choose build type from: None Debug Release RelWithDebInfo MinSizeRel"
        FORCE)
endif()

if(MSVC)
  add_definitions(-D_CRT_SECURE_NO_WARNINGS)
  if(NOT DEFINED ENV{VSCMD_VER})
    set(CMAKE_MSVCIDE_RUN_PATH $ENV{PATH})
  endif()
endif()

# link import library
find_package(VPL REQUIRED)
target_link_libraries(${TARGET} PRIVATE VPL::dispatcher)

if(WIN32)
  # Windows dependencies
  target_link_libraries(${TARGET} PRIVATE dxgi d3d11)
else()
  # Linux dependencies
  find_package(PkgConfig REQUIRED)

  find_package(Threads REQUIRED)
  set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
  set(THREADS_PREFER_PTHREAD_FLAG TRUE)

  pkg_check_modules(PKG_LIBVA IMPORTED_TARGET libva>=1.2)
  pkg_check_modules(PKG_LIBVA_DRM IMPORTED_TARGET libva-drm>=1.2)

  if(PKG_LIBVA_FOUND)
    target_include_directories(${TARGET} PUBLIC ${PKG_LIBVA_INCLUDE_DIRS})

    target_link_libraries(${TARGET} PRIVATE Threads::Threads)
    target_link_libraries(${TARGET} PRIVATE PkgConfig::PKG_LIBVA
                                            PkgConfig::PKG_LIBVA_DRM)
  else()
    message(SEND_ERROR "Missing packages: libva, libva_drm, x11 are required.")
  endif()
endif()

install(TARGETS ${TARGET} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
                                  COMPONENT ${VPL_COMPONENT_TOOLS})

=== tools/cli/vpl-import-export/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################
cmake_minimum_required(VERSION 3.10.2)
project(vpl-import-export)

if(NOT BUILD_EXPERIMENTAL)
  message(
    WARNING
      "BUILD_EXPERIMENTAL is set to OFF. vpl-import-export will not be built.")
  return()
endif()

# Default install places 64 bit runtimes in the environment, so we want to do a
# 64 bit build by default.
if(WIN32)
  if(NOT DEFINED CMAKE_GENERATOR_PLATFORM)
    set(CMAKE_GENERATOR_PLATFORM
        x64
        CACHE STRING "")
    message(STATUS "Generator Platform set to ${CMAKE_GENERATOR_PLATFORM}")
  endif()
endif()

set(TARGET vpl-import-export)

add_executable(${TARGET})

target_compile_definitions(${TARGET} PRIVATE -DONEVPL_EXPERIMENTAL)

target_sources(${TARGET} PRIVATE src/vpl-import-export.cpp src/decode-vpp.cpp
                                 src/encode.cpp src/util.cpp src/debug.cpp)

if(WIN32)
  target_sources(${TARGET} PRIVATE src/hw-device-d3d11.cpp)
else()
  target_sources(${TARGET} PRIVATE src/hw-device-vaapi.cpp)
endif()

if(TOOLS_ENABLE_SCREEN_CAPTURE)
  target_compile_definitions(${TARGET} PRIVATE -DTOOLS_ENABLE_SCREEN_CAPTURE)
  if(WIN32)
    target_sources(${TARGET} PRIVATE src/capture-frames-d3d11.cpp)
  else()
    target_sources(${TARGET} PRIVATE src/capture-frames-vaapi.cpp)
  endif()
endif()

if(TOOLS_ENABLE_RENDER)
  target_compile_definitions(${TARGET} PRIVATE -DTOOLS_ENABLE_RENDER)
  if(WIN32)
    target_sources(${TARGET} PRIVATE src/render-frames-d3d11.cpp)
  else()
    target_sources(${TARGET} PRIVATE src/render-frames-vaapi.cpp)
  endif()
endif()

# OpenCL is currently supported on Windows only for this tool
if(WIN32)
  # if OpenCL is not configured, disable use of it in this tool and print
  # warning
  find_package(OpenCL CONFIG)
  if(NOT OpenCL_FOUND)
    message(
      WARNING "*** OpenCL not found. OpenCL surface sharing will be disabled.")
    set(TOOLS_ENABLE_OPENCL OFF)
  endif()

  if(TOOLS_ENABLE_OPENCL)
    target_compile_definitions(${TARGET} PRIVATE -DTOOLS_ENABLE_OPENCL)
    target_sources(${TARGET} PRIVATE src/process-frames-ocl-d3d11.cpp)
    target_link_libraries(${TARGET} PRIVATE OpenCL::OpenCL)
  endif()
endif()

# Set default build type to Release if not specified
if(NOT CMAKE_BUILD_TYPE)
  message(STATUS "Default CMAKE_BUILD_TYPE not set using Release")
  set(CMAKE_BUILD_TYPE
      "Release"
      CACHE
        STRING
        "Choose build type from: None Debug Release RelWithDebInfo MinSizeRel"
        FORCE)
endif()

if(MSVC)
  add_definitions(-D_CRT_SECURE_NO_WARNINGS)
  if(NOT DEFINED ENV{VSCMD_VER})
    set(CMAKE_MSVCIDE_RUN_PATH $ENV{PATH})
  endif()
endif()

# link import library
find_package(VPL REQUIRED)
target_link_libraries(${TARGET} PRIVATE VPL::dispatcher)

if(WIN32)
  # Windows dependencies
  target_link_libraries(${TARGET} PRIVATE dxgi d3d11 dxguid.lib)
else()
  # Linux dependencies
  find_package(PkgConfig REQUIRED)

  find_package(Threads REQUIRED)
  set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
  set(THREADS_PREFER_PTHREAD_FLAG TRUE)

  target_link_libraries(${TARGET} PRIVATE Threads::Threads)

  pkg_check_modules(PKG_LIBVA IMPORTED_TARGET libva>=1.2)
  pkg_check_modules(PKG_LIBVA_DRM IMPORTED_TARGET libva-drm>=1.2)

  if(PKG_LIBVA_FOUND AND PKG_LIBVA_DRM_FOUND)
    target_include_directories(${TARGET} PUBLIC ${PKG_LIBVA_INCLUDE_DIRS})
    target_link_libraries(${TARGET} PRIVATE PkgConfig::PKG_LIBVA
                                            PkgConfig::PKG_LIBVA_DRM)
  else()
    message(SEND_ERROR "Missing packages: libva, libva_drm are required.")
  endif()

  if(TOOLS_ENABLE_X11)
    target_compile_definitions(${TARGET} PRIVATE -DTOOLS_ENABLE_X11)

    pkg_check_modules(PKG_X11 x11 IMPORTED_TARGET)
    pkg_check_modules(PKG_LIBVA_X11 libva-x11>=1.10.0 IMPORTED_TARGET)

    if(PKG_X11_FOUND AND PKG_LIBVA_X11_FOUND)
      target_link_libraries(${TARGET} PRIVATE PkgConfig::PKG_X11
                                              PkgConfig::PKG_LIBVA_X11)
    else()
      message(
        SEND_ERROR
          "Missing packages: x11, libva_x11 are required. Set TOOLS_ENABLE_X11=OFF to disable X11 code."
      )
    endif()
  else()
    message(WARNING,
            "TOOLS_ENABLE_X11 is set to OFF. X11 code will be disabled")
  endif()
endif()

install(TARGETS ${TARGET} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
                                  COMPONENT ${VPL_COMPONENT_TOOLS})

=== tools/cli/vpl-inspect/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################
cmake_minimum_required(VERSION 3.13.0)

if(MSVC)
  add_definitions(-D_CRT_SECURE_NO_WARNINGS)
endif()

add_executable(vpl-inspect src/vpl-inspect.cpp)
find_package(VPL REQUIRED)
target_link_libraries(vpl-inspect PUBLIC VPL::dispatcher)
target_include_directories(vpl-inspect PRIVATE ${ONEVPL_API_HEADER_DIRECTORY})

if(BUILD_EXPERIMENTAL)
  target_compile_definitions(vpl-inspect PRIVATE -DONEVPL_EXPERIMENTAL)
endif()

install(TARGETS vpl-inspect RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
                                    COMPONENT ${VPL_COMPONENT_TOOLS})

=== tools/legacy/media_sdk_compatibility_headers/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) 2021 Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################

set(TARGET media_sdk_compatibility_headers)

add_library(${TARGET} INTERFACE)

target_include_directories(${TARGET} INTERFACE ${CMAKE_CURRENT_SOURCE_DIR})

=== tools/legacy/metrics_monitor/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) 2017 Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################

if(NOT CMAKE_SYSTEM_NAME MATCHES Linux)
  return()
endif()

find_package(PkgConfig REQUIRED)
# note: pkg-config version for libva is *API* version
pkg_check_modules(PKG_LIBVA libva>=1.2 IMPORTED_TARGET GLOBAL)
pkg_check_modules(PKG_LIBVA_DRM libva-drm>=1.2 IMPORTED_TARGET GLOBAL)
pkg_check_modules(PKG_LIBDRM libdrm>=2.4.91 IMPORTED_TARGET)
pkg_check_modules(PKG_PCIACCESS pciaccess)
# Set defaults for ENABLE_VA
if(PKG_LIBVA_FOUND AND PKG_LIBVA_DRM_FOUND)
  set(VA_DEFAULT ON)
else()
  set(VA_DEFAULT OFF)
endif()
set(ENABLE_VA
    ${VA_DEFAULT}
    CACHE BOOL "Enable VA support in tools.")

if(NOT ENABLE_VA)
  message(STATUS "VA support disabled. Skipping metrics_monitor.")
  return()
endif()

# Set default for ENABLE_DRM
if(VA_DEFAULT AND PKG_LIBDRM_FOUND)
  set(DRM_DEFAULT ON)
else()
  set(DRM_DEFAULT OFF)
endif()
set(ENABLE_DRM
    ${DRM_DEFAULT}
    CACHE BOOL "Enable VA/DRM in tools.")

# Error if options conflict
if(NOT ENABLE_VA AND ENABLE_DRM)
  message(
    SEND_ERROR "conflicting options: DRM backend requested but ENABLE_VA=OFF")
endif()

# cttmetrics
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include/)

set(sources
    include/cttmetrics.h include/cttmetrics_utils.h src/cttmetrics.cpp
    src/cttmetrics_i915_custom.cpp src/cttmetrics_i915_pmu.cpp
    src/cttmetrics_utils.cpp)

file(GLOB_RECURSE srcs "${CMAKE_CURRENT_SOURCE_DIR}/src/*.cpp")
list(APPEND sources ${srcs})

if(PKG_LIBDRM_FOUND)
  set(DEPENDENCIES libdrm)
  set(METRICS_LIB cttmetrics)

  if(BUILD_SHARED_LIBS)
    add_library(${METRICS_LIB} SHARED ${sources})
    set_target_properties(${METRICS_LIB} PROPERTIES VERSION 1.0.0)
    install(TARGETS ${METRICS_LIB} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
                                           COMPONENT ${VPL_COMPONENT_TOOLS})
  else()
    add_library(${METRICS_LIB} STATIC ${sources})
  endif()

  target_include_directories(${METRICS_LIB} PUBLIC include)
  target_link_libraries(${METRICS_LIB} PRIVATE PkgConfig::PKG_LIBDRM)
  target_compile_definitions(${METRICS_LIB} PRIVATE LIBVA_DRM_SUPPORT
                                                    LIBVA_SUPPORT)

  # metrics_monitor
  set(sources sample/cttmetrics_sample.cpp)
  set(METRICS_TOOL metrics_monitor)

  file(GLOB_RECURSE srcs "${CMAKE_CURRENT_SOURCE_DIR}/sample/*.cpp")

  add_executable(${METRICS_TOOL} ${sources})
  set_property(TARGET ${METRICS_TOOL} PROPERTY FOLDER "samples")
  if(NOT CMAKE_C_COMPILER_ID MATCHES Intel)
    set_property(TARGET ${METRICS_TOOL}
                 PROPERTY INTERPROCEDURAL_OPTIMIZATION_RELEASE TRUE)
  endif()

  target_link_libraries(${METRICS_TOOL} PUBLIC ${METRICS_LIB})

  target_compile_definitions(${METRICS_TOOL} PRIVATE LIBVA_DRM_SUPPORT
                                                     LIBVA_SUPPORT)

  install(TARGETS ${METRICS_TOOL} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
                                          COMPONENT ${VPL_COMPONENT_TOOLS})

  # test_monitor
  if(BUILD_TESTS)
    if(PKG_PCIACCESS_FOUND)

      set(test_srcs
          test/device_info.h test/i915_pciids.h test/igt_load.c test/igt_load.h
          test/cttmetrics_gtest.cpp test/device_info.c)

      add_executable(test_monitor ${test_srcs})

      if(NOT CMAKE_C_COMPILER_ID MATCHES Intel)
        set_property(TARGET test_monitor
                     PROPERTY INTERPROCEDURAL_OPTIMIZATION_RELEASE TRUE)
      endif()

      target_include_directories(test_monitor PRIVATE ./include)
      target_link_libraries(test_monitor PRIVATE pthread rt gtest cttmetrics
                                                 PkgConfig::PKG_LIBDRM)

    else()
      message(
        SEND_ERROR
          "pciaccess not found: set BUILD_TESTS=OFF to skip building test_monitor"
      )
    endif()
  endif()
else()
  message(STATUS "libdrm not found: skipping build of metrics_monitor")
endif()

=== tools/legacy/sample_common/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) 2005 Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################
set(TOOLS_DEFAULT ON)
if(CMAKE_SYSTEM_NAME MATCHES Linux)
  # Check dependencies up-front so we can set option defaults
  find_package(PkgConfig REQUIRED)
  # note: pkg-config version for libva is *API* version
  pkg_check_modules(PKG_LIBVA libva>=1.2 IMPORTED_TARGET GLOBAL)
  pkg_check_modules(PKG_LIBVA_DRM libva-drm>=1.2 IMPORTED_TARGET GLOBAL)
  pkg_check_modules(PKG_LIBDRM libdrm>=2.4.91 IMPORTED_TARGET GLOBAL)
  pkg_check_modules(PKG_X11 x11 IMPORTED_TARGET GLOBAL)
  pkg_check_modules(PKG_LIBVA_X11 libva-x11>=1.10.0 IMPORTED_TARGET GLOBAL)
  pkg_check_modules(
    PKG_XCB
    xcb
    xcb-dri3
    x11-xcb
    xcb-present
    IMPORTED_TARGET
    GLOBAL)
  pkg_check_modules(PKG_WAYLAND_CLIENT wayland-client IMPORTED_TARGET GLOBAL)
  find_program(WAYLAND_SCANNER_BIN "wayland-scanner")
  pkg_check_modules(PKG_WAYLAND_PROTOCOLS "wayland-protocols>=1.15")
  pkg_check_modules(PKG_GTK4 GLOBAL IMPORTED_TARGET gtkmm-4.0)
  pkg_check_modules(PKG_EPOXY GLOBAL IMPORTED_TARGET epoxy)
  find_package(OpenGL)
  # Set defaults for ENABLE_VA
  if(PKG_LIBVA_FOUND AND PKG_LIBVA_DRM_FOUND)
    set(VA_DEFAULT ON)
  else()
    set(VA_DEFAULT OFF)
  endif()
  set(ENABLE_VA
      ${VA_DEFAULT}
      CACHE BOOL "Enable VA support in tools.")

  # Set default for ENABLE_DRM
  if(VA_DEFAULT AND PKG_LIBDRM_FOUND)
    set(DRM_DEFAULT ON)
  else()
    set(DRM_DEFAULT OFF)
  endif()
  set(ENABLE_DRM
      ${DRM_DEFAULT}
      CACHE BOOL "Enable VA/DRM in tools.")

  # Set default for ENABLE_WAYLAND
  if(VA_DEFAULT
     AND DRM_DEFAULT
     AND PKG_WAYLAND_CLIENT_FOUND
     AND WAYLAND_SCANNER_BIN
     AND PKG_WAYLAND_PROTOCOLS_FOUND)
    set(WAYLAND_DEFAULT ON)
  else()
    set(WAYLAND_DEFAULT OFF)
  endif()
  set(ENABLE_WAYLAND
      ${WAYLAND_DEFAULT}
      CACHE BOOL "Enable VA/Wayland in tools.")

  # Set default for ENABLE_X11
  if(VA_DEFAULT AND PKG_X11_FOUND)
    set(X11_DEFAULT ON)
  else()
    set(X11_DEFAULT OFF)
  endif()
  set(ENABLE_X11
      ${X11_DEFAULT}
      CACHE BOOL "Enable VA/X11 in tools.")
  # set default for ENABLE_DRI3
  if(X11_DEFAULT
     AND PKG_XCB_FOUND
     AND PKG_LIBDRM_FOUND)
    set(DRI3_DEFAULT ON)
  else()
    set(DRI3_DEFAULT OFF)
  endif()
  set(ENABLE_DRI3
      ${DRI3_DEFAULT}
      CACHE BOOL "Enable X11/DRI3 in tools.")

  if(X11_DEFAULT AND PKG_GTK4_FOUND)
    set(GTK4_DEFAULT ON)
  else()
    set(GTK4_DEFAULT OFF)
  endif()

  set(ENABLE_GTK4
      ${GTK4_DEFAULT}
      CACHE BOOL "Enable X11/GTK4 in tools.")

endif()

# Error if options conflict
if(NOT ENABLE_VA
   AND (ENABLE_DRM
        OR ENABLE_WAYLAND
        OR ENABLE_X11
        OR ENABLE_DRI3
        OR ENABLE_GTK4
       ))
  message(
    SEND_ERROR "conflicting options: VA backend requested but ENABLE_VA=OFF")
endif()

if(ENABLE_WAYLAND AND NOT ENABLE_DRM)
  message(SEND_ERROR "conflicting options: Wayland requires ENABLE_DRM=ON")
endif()

if(ENABLE_DRI3 AND (NOT ENABLE_X11 OR NOT ENABLE_DRM))
  message(
    SEND_ERROR
      "conflicting options: DRI3 requires ENABLE_X11=ON and ENABLE_DRM=ON")
endif()

if(ENABLE_GTK4 AND (NOT ENABLE_X11 OR NOT ENABLE_DRM))
  message(
    SEND_ERROR
      "conflicting options: GTK4 requires ENABLE_X11=ON and ENABLE_DRM=ON")
endif()

set(TARGET sample_common)
add_library(${TARGET} STATIC)

target_sources(
  ${TARGET}
  PRIVATE src/avc_bitstream.cpp
          src/avc_nal_spl.cpp
          src/avc_spl.cpp
          src/base_allocator.cpp
          src/brc_routines.cpp
          src/d3d11_allocator.cpp
          src/d3d11_device.cpp
          src/d3d_allocator.cpp
          src/d3d_device.cpp
          src/decode_render.cpp
          src/general_allocator.cpp
          src/mfx_buffering.cpp
          src/parameters_dumper.cpp
          src/plugin_utils.cpp
          src/preset_manager.cpp
          src/sample_utils.cpp
          src/sysmem_allocator.cpp
          src/v4l2_util.cpp
          src/vaapi_allocator.cpp
          src/vaapi_device.cpp
          src/vaapi_utils_android.cpp
          src/vaapi_utils.cpp
          src/vaapi_utils_drm.cpp
          src/vaapi_utils_x11.cpp
          src/vaapi_utils_gtk.cpp
          src/vpl_implementation_loader.cpp
          src/vpp_ex.cpp
          src/vm/atomic.cpp
          src/vm/atomic_linux.cpp
          src/vm/shared_object.cpp
          src/vm/shared_object_linux.cpp
          src/vm/thread_linux.cpp
          src/vm/thread_windows.cpp
          src/vm/time.cpp
          src/vm/time_linux.cpp
          src/gtkutils.cpp)

target_include_directories(
  ${TARGET} PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/include
                   ${CMAKE_CURRENT_SOURCE_DIR}/include/vm)

target_compile_definitions(${TARGET}
                           PUBLIC TOOLS_VERSION_MAJOR=${PROJECT_VERSION_MAJOR})
target_compile_definitions(${TARGET}
                           PUBLIC TOOLS_VERSION_MINOR=${PROJECT_VERSION_MINOR})
target_compile_definitions(${TARGET}
                           PUBLIC TOOLS_VERSION_PATCH=${PROJECT_VERSION_PATCH})

if(MSVC)
  target_compile_definitions(${TARGET} PUBLIC _CRT_SECURE_NO_WARNINGS)
endif()

target_compile_definitions(${TARGET} PUBLIC MFX_DEPRECATED_OFF)

find_package(VPL REQUIRED)
target_link_libraries(${TARGET} PUBLIC VPL::dispatcher
                                       media_sdk_compatibility_headers)

if(BUILD_EXPERIMENTAL)
  target_compile_definitions(${TARGET} PUBLIC -DONEVPL_EXPERIMENTAL)
endif()

if(CMAKE_SYSTEM_NAME MATCHES Linux)
  target_compile_definitions(${TARGET} PUBLIC LINUX64)

  if(NOT ENABLE_VA)
    message(STATUS "Building ${TARGET} without VA support")
  else()
    if(PKG_LIBVA_FOUND AND PKG_LIBVA_DRM_FOUND)
      target_compile_definitions(${TARGET} PUBLIC LIBVA_SUPPORT)
      target_include_directories(${TARGET} PUBLIC ${PKG_LIBVA_INCLUDE_DIRS})

      if(ENABLE_DRM)
        if(PKG_LIBDRM_FOUND)
          target_compile_definitions(${TARGET} PUBLIC LIBVA_DRM_SUPPORT)
          target_include_directories(${TARGET}
                                     PUBLIC ${PKG_LIBDRM_INCLUDE_DIRS})

          if("${PKG_LIBDRM_VERSION}" VERSION_GREATER 2.4.113)
            target_compile_definitions(${TARGET}
                                       PUBLIC DRM_LINUX_MODIFIER_TILED4_SUPPORT)
          else()
            message(
              STATUS
                "libdrm version ${PKG_LIBDRM_VERSION} does not support I915_FORMAT_MOD_4_TILED"
            )
          endif()

          if("${PKG_LIBDRM_VERSION}" VERSION_GREATER 2.4.107)
            target_compile_definitions(
              ${TARGET} PUBLIC DRM_LINUX_FORMAT_MODIFIER_BLOB_SUPPORT)
          else()
            message(
              STATUS
                "libdrm version ${PKG_LIBDRM_VERSION} does not support drmModeFormatModifierBlobIterNext() API"
            )
          endif()

          if("${PKG_LIBDRM_VERSION}" VERSION_GREATER 2.4.104)
            target_compile_definitions(${TARGET} PUBLIC DRM_LINUX_HDR_SUPPORT)
          else()
            message(
              STATUS
                "libdrm version ${PKG_LIBDRM_VERSION} does not support hdr_output_metadata header"
            )
          endif()

          if("${PKG_LIBDRM_VERSION}" VERSION_GREATER 2.4.97)
            target_compile_definitions(${TARGET} PUBLIC DRM_LINUX_P010_SUPPORT)
          else()
            message(
              STATUS
                "libdrm version ${PKG_LIBDRM_VERSION} does not support DRM_FORMAT_P010"
            )
          endif()

        else()
          message(
            SEND_ERROR
              "libdrm not found: set ENABLE_DRM=OFF to to build tools with DRM disabled"
          )
        endif()
      else()
        message(STATUS "Building ${TARGET} without DRM support")
      endif()

      if(ENABLE_WAYLAND)
        if(PKG_WAYLAND_CLIENT_FOUND)
          target_compile_definitions(${TARGET} PUBLIC LIBVA_WAYLAND_SUPPORT)
          target_include_directories(${TARGET}
                                     PUBLIC ${PKG_WAYLAND_CLIENT_INCLUDE_DIRS})
          target_include_directories(
            ${TARGET}
            PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/../sample_misc/wayland/include)
          if(WAYLAND_SCANNER_BIN AND PKG_WAYLAND_PROTOCOLS_FOUND)
            pkg_get_variable(WAYLAND_PROTOCOLS_PATH wayland-protocols
                             pkgdatadir)
            if(WAYLAND_PROTOCOLS_PATH)
              find_file(
                WAYLAND_LINUX_DMABUF_XML_PATH linux-dmabuf-unstable-v1.xml
                PATHS ${WAYLAND_PROTOCOLS_PATH}/unstable/linux-dmabuf
                NO_DEFAULT_PATH)
              find_file(WAYLAND_LINUX_XDG_SHELL_XML_PATH xdg-shell.xml
                        PATHS ${WAYLAND_PROTOCOLS_PATH}/stable/xdg-shell
                              NO_DEFAULT_PATH)
            endif()
          else()
            message(
              SEND_ERROR
                "wayland-protocols not found: set ENABLE_WAYLAND=OFF to build tools with Wayland disabled"
            )
          endif()

          if(WAYLAND_LINUX_DMABUF_XML_PATH)
            target_compile_definitions(${TARGET}
                                       PUBLIC WAYLAND_LINUX_DMABUF_SUPPORT)
            target_include_directories(
              ${TARGET}
              PUBLIC ${CMAKE_BINARY_DIR}/tools/legacy/sample_misc/wayland)
          endif()

          if(WAYLAND_LINUX_XDG_SHELL_XML_PATH)
            target_compile_definitions(${TARGET}
                                       PUBLIC WAYLAND_LINUX_XDG_SHELL_SUPPORT)
            target_include_directories(
              ${TARGET}
              PUBLIC ${CMAKE_BINARY_DIR}/tools/legacy/sample_misc/wayland)
          else()
            message(SEND_ERROR "xdg-shell.xml could not be found")
          endif()

        else()
          message(
            SEND_ERROR
              "wayland-client not found: set ENABLE_WAYLAND=OFF to build tools with Wayland disabled"
          )
        endif()
      else()
        message(STATUS "Building ${TARGET} without Wayland support")
      endif()

      if(ENABLE_X11)
        if(PKG_X11_FOUND)
          target_compile_definitions(${TARGET} PUBLIC LIBVA_X11_SUPPORT)
          target_link_libraries(${TARGET} PUBLIC PkgConfig::PKG_X11)

          if(ENABLE_DRI3)
            if(PKG_XCB_FOUND AND PKG_LIBDRM_FOUND)
              target_compile_definitions(${TARGET} PUBLIC X11_DRI3_SUPPORT)
              target_link_libraries(${TARGET} PUBLIC PkgConfig::PKG_XCB)
            else()
              message(
                SEND_ERROR
                  "DRI3 dependencies not found: set ENABLE_DRI3=OFF to to build tools with DRI3 disabled"
              )
            endif()
          else()
            message(STATUS "Building ${TARGET} without DRI3 support")
          endif()

        else()
          message(
            SEND_ERROR
              "X11 modules not found: set ENABLE_X11=OFF to build tools with X11 disabled"
          )
        endif()
      else()
        message(STATUS "Building ${TARGET} without X11 support")
      endif()

      if(ENABLE_GTK4)
        target_compile_definitions(${TARGET} PUBLIC LIBVA_GTK4_SUPPORT)
        target_link_libraries(${TARGET} PUBLIC PkgConfig::PKG_GTK4)
        target_link_libraries(${TARGET} PUBLIC OpenGL::GL)
        target_include_directories(${TARGET} PUBLIC OpenGL::GL)
        target_link_libraries(${TARGET} PUBLIC PkgConfig::PKG_EPOXY)
        target_include_directories(${TARGET} PUBLIC PkgConfig::PKG_EPOXY)
      endif()

    else()
      message(
        SEND_ERROR
          "libva not found: set ENABLE_VA=OFF to build tools with VA disabled")
    endif()
  endif()

  target_link_libraries(${TARGET} PUBLIC ${CMAKE_DL_LIBS})

  set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
  set(THREADS_PREFER_PTHREAD_FLAG TRUE)
  find_package(Threads REQUIRED)
  target_link_libraries(${TARGET} PUBLIC Threads::Threads)
else()

=== tools/legacy/sample_decode/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) 2005 Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################

find_package(VPL REQUIRED)

add_executable(sample_decode)

target_sources(sample_decode PRIVATE src/pipeline_decode.cpp
                                     src/sample_decode.cpp)

target_include_directories(sample_decode
                           PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/include)

target_link_libraries(sample_decode PRIVATE sample_common)

if(BUILD_EXPERIMENTAL)
  target_compile_definitions(sample_decode PRIVATE -DONEVPL_EXPERIMENTAL)
endif()

if(MSVC)
  target_compile_definitions(sample_decode PRIVATE -D_CRT_SECURE_NO_WARNINGS)
endif()

install(TARGETS sample_decode RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
                                      COMPONENT ${VPL_COMPONENT_TOOLS})

=== tools/legacy/sample_encode/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) 2005 Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################

find_package(VPL REQUIRED)

add_executable(sample_encode)

target_sources(
  sample_encode PRIVATE src/pipeline_encode.cpp src/pipeline_region_encode.cpp
                        src/pipeline_user.cpp src/sample_encode.cpp)

target_include_directories(sample_encode
                           PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/include)

target_link_libraries(sample_encode PRIVATE sample_common)

if(BUILD_EXPERIMENTAL)
  target_compile_definitions(sample_encode PRIVATE -DONEVPL_EXPERIMENTAL)
endif()

if(MSVC)
  target_compile_definitions(sample_encode PRIVATE _CRT_SECURE_NO_WARNINGS)
endif()

install(TARGETS sample_encode RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
                                      COMPONENT ${VPL_COMPONENT_TOOLS})

=== tools/legacy/sample_multi_transcode/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) 2005 Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################

find_package(VPL REQUIRED)

add_executable(sample_multi_transcode)

target_sources(
  sample_multi_transcode
  PRIVATE src/pipeline_transcode.cpp src/sample_multi_transcode.cpp
          src/smt_cli.cpp src/smt_tracer.cpp src/main.cpp)

target_link_libraries(sample_multi_transcode PRIVATE sample_common)

target_include_directories(
  sample_multi_transcode PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/include
                                 ${CMAKE_SOURCE_DIR}/api/vpl)

if(BUILD_EXPERIMENTAL)
  target_compile_definitions(sample_multi_transcode
                             PRIVATE -DONEVPL_EXPERIMENTAL)
endif()

target_compile_definitions(sample_multi_transcode PRIVATE MFX_ONEVPL)

install(TARGETS sample_multi_transcode
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
                COMPONENT ${VPL_COMPONENT_TOOLS})

if(BUILD_TESTS)
  set(BUILD_SHARED_LIBS OFF)

  set(BUILD_GMOCK
      OFF
      CACHE BOOL "" FORCE)
  set(INSTALL_GTEST
      OFF
      CACHE BOOL "" FORCE)
  set(gtest_disable_pthreads
      OFF
      CACHE BOOL "" FORCE)
  set(gtest_force_shared_crt
      ON
      CACHE BOOL "" FORCE)
  set(gtest_hide_internal_symbols
      OFF
      CACHE BOOL "" FORCE)

  add_executable(sample_multi_transcode_test)
  target_sources(
    sample_multi_transcode_test
    PRIVATE src/pipeline_transcode.cpp src/sample_multi_transcode.cpp
            src/smt_cli.cpp src/smt_tracer.cpp test/test_main.cpp)

  target_link_libraries(sample_multi_transcode_test PUBLIC GTest::gtest)
  target_link_libraries(sample_multi_transcode_test PRIVATE sample_common)
  target_include_directories(
    sample_multi_transcode_test PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/include
                                        ${CMAKE_SOURCE_DIR}/api/vpl)

  if(BUILD_EXPERIMENTAL)
    target_compile_definitions(sample_multi_transcode_test
                               PRIVATE -DONEVPL_EXPERIMENTAL)
  endif()

  target_compile_definitions(sample_multi_transcode_test PRIVATE MFX_ONEVPL)

  include(GoogleTest)
  gtest_discover_tests(sample_multi_transcode_test)

endif()

=== debian/changelog ===
libvpl-tools (1.4.0-2) unstable; urgency=medium

  * patches: Fix build with gcc-15. (Closes: #1097288)

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 19 Aug 2025 21:16:46 +0300

libvpl-tools (1.4.0-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump build-depends on libvpl-dev.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 12 Aug 2025 09:25:47 +0300

=== debian/control ===
Source: libvpl-tools
Section: graphics
Priority: optional
Maintainer: Timo Aaltonen <tjaalton@debian.org>
Build-Depends: debhelper-compat (= 13),
 cmake,
 pkgconf,
 libdrm-dev,
 libva-dev,
 libvpl-dev (>= 1:2.15.0),
 libx11-dev,
 libx11-xcb-dev,
 libxcb-present-dev,
 libxcb-dri3-dev,
 libwayland-dev,
 wayland-protocols,
Standards-Version: 4.7.0
Homepage: https://github.com/intel/libvpl-tools
Vcs-Browser: https://salsa.debian.org/debian/libvpl-tools
Vcs-Git: https://salsa.debian.org/debian/libvpl-tools.git
Rules-Requires-Root: no

Package: libvpl-tools
Architecture: amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: onevpl-tools
Provides: onevpl-tools
Replaces: onevpl-tools
Description: Intel Video Processing Library -- command line tools
 Intel Video Processing Library (Intel VPL) provides access to hardware
 accelerated video decode, encode, and processing capabilities on Intel
 GPUs to support AI visual inference, media delivery, cloud gaming, and virtual
 desktop infrastructure use cases.
 .
 This package includes the command line tools.

=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4

# PGP signature mangle, so foo.tar.gz has foo.tar.gz.sig
#opts="pgpsigurlmangle=s%$%.sig%"

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%libvpl-tools-$1.tar.gz%" \
   https://github.com/intel/libvpl-tools/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz

## libvpl-tools 1.5.0

=== debian/changelog ===
libvpl-tools (1.5.0-1) unstable; urgency=medium

  * New upstream release.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 24 Feb 2026 09:41:19 +0200
